

glorynow_currentclicked = nil;
glorynow_currentover = nil;

glorynow_currentclickedach = nil;

glorynow_currenttimer = false;
glorynow_time = "0";

glorynow_icons = { 
			"Interface/LFGFrame/LFGIcon-Utgarde",
			"Interface/LFGFrame/LFGIcon-UtgardePinnacle",
			"Interface/LFGFrame/LFGIcon-TheNexus",
			"Interface/LFGFrame/LFGIcon-TheOculus",
			"Interface/LFGFrame/LFGIcon-AzjolNerub",
			"Interface/LFGFrame/LFGIcon-Ahnkalet",
			"Interface/LFGFrame/LFGIcon-HallsofStone",
			"Interface/LFGFrame/LFGIcon-HallsofLightning",
			"Interface/LFGFrame/LFGIcon-DrakTharon",
			"Interface/LFGFrame/LFGIcon-TheVioletHold",
			"Interface/LFGFrame/LFGIcon-Gundrak",
			"Interface/LFGFrame/LFGIcon-OldStratholme"
			};
glorynow_names = { "Utgarde Keep",
			"Utgarde Pinnacle",
			"The Nexus",
			"The Oculus",
			"Azjol-Nerub",
			"Ahn'kahet: The Old Kingdom",
			"The Halls of Stone",
			"The Halls of Lightning",
			"Drak'Tharon Keep",
			"The Violet Hold",
			"Gundrak",
			"The Culling of Stratholme"
			};
glorynow_ids = { { 1919 },
			{ 2043, 2156, 1873, 2157 },
			{ 2037, 2150, 2036 },
			{ 1868, 1871, 2044, 2045, 2046 },
			{ 1296, 1297, 1860 },
			{ 2038, 1861, 2056, 1862 },
			{ 1866, 2154, 2155 },
			{ 1834, 2042, 1867 },
			{ 2151, 2057, 2039 },
			{ 1816, 2153, 2041, 1865 },
			{ 2040, 2058, 1864, 2152 },
			{ 1872, 1817 }
			};

glorynow_saved = { [1866]={},
			[1868]={},
			[1873]={},
			[1860]={},
			[1862]={},
			[1867]={},
			[1817]={}
			 };
	 
glorynow_bosses = { 	["Maiden of Grief"]="You shouldn't have come... now you will die!",
				["Drakos the Interrogator"]="The prisoners shall not go free. The word of Malygos is law!",
				["Skadi the Ruthless"]="What mongrels dare intrude here? Look alive, my brothers!  A feast for the one that brings me their heads!",
				["Anub'arak"]="Eternal agony awaits you!",
				["Herald Volazj"]="Shgla'yos plahf mh'naus.",
				["Loken"]="What hope is there for you? None!"
				
			};
				

glorynow_bossids = {    ["Maiden of Grief"]={1866,60},
				["Ley-Guardian Eregos"]={1868,1200},
				["Skadi the Ruthless"]={1873,180},
				["Anub'arak"]={1860,120},
				["Herald Volazj"]={1862,120},
				["Loken"]={1867,120},
				["Infinite Corruptor"]={1817,1800}
			};

function GloryNow_CheckForSpecialAchievement(id)
	if ( glorynow_saved[id] ) then
		GloryNowCrit1:SetText("");
		GloryNowCrit2:SetText("");
		GloryNowCrit3:SetText("");
		GloryNowCrit4:SetText("");
		GloryNowCrit5:SetText("");
		GloryNowCrit6:SetText("");			
	
		if ( glorynow_saved[id][1] ) then
			local stringseconds = glorynow_saved[id][2];
			if ( stringseconds < 10 ) then
				stringseconds = "0"..tostring(stringseconds);
			end	
			GloryNowRecordTime1:SetText("Best time:");
			GloryNowRecordTime2:SetText(glorynow_saved[id][1]..":"..stringseconds);
			
		else
			GloryNowRecordTime1:SetText("");
			GloryNowRecordTime2:SetText("");	
		end	
	else
		GloryNowRecordTime1:SetText("");
		GloryNowRecordTime2:SetText("");
		--check for criterias
		local critnum = GetAchievementNumCriteria(id);
		if ( critnum ) and ( critnum > 0 ) then
			for i=1,critnum,1 do
				local name,_,comp = GetAchievementCriteriaInfo(id, i);
				getglobal("GloryNowCrit"..i):SetText(name);
				if ( comp ) then
					getglobal("GloryNowCrit"..i):SetTextColor(0.2,1,0.2,1);
				else
					getglobal("GloryNowCrit"..i):SetTextColor(0.4,0.4,0.4,1);
				end
			end
			for i=critnum+1,6,1 do
				getglobal("GloryNowCrit"..i):SetText("");
			end
			if ( critnum > 2 ) then
				local diff31 = GloryNowCrit1:GetStringWidth()-GloryNowCrit3:GetStringWidth();
				diff31 = math.floor(tonumber(diff31));
				if diff31 > 0 and math.fmod(tonumber(diff31), 2) > 0 then
					diff31 = diff31 + 1;
				end
				diff31 = diff31 / 2;
				GloryNowCrit2:ClearAllPoints();
				if ( critnum > 3 ) then
					GloryNowCrit2:SetPoint("TOPLEFT", GloryNowBG1, "TOPLEFT", (380-(GloryNowCrit2:GetWidth()/2))+diff31, -205);
				else
					GloryNowCrit2:SetPoint("TOPLEFT", GloryNowBG1, "TOPLEFT", (380-(GloryNowCrit2:GetWidth()/2))+diff31, -212);
				end
				if ( critnum == 5 ) then
					local diff54 = GloryNowCrit4:GetStringWidth()-GloryNowCrit5:GetStringWidth();
					diff54 = math.floor(tonumber(diff54));
					if diff54 > 0 and math.fmod(tonumber(diff54), 2) > 0 then
						diff54 = diff54 + 1;
					end
					diff54 = diff54 / 2;
					GloryNowCrit5:ClearAllPoints();
					GloryNowCrit5:SetPoint("TOPLEFT", GloryNowBG1, "TOPLEFT", (386+diff54), -223);				
				elseif ( critnum == 4 ) then
					GloryNowCrit5:SetText(GloryNowCrit4:GetText());
					GloryNowCrit5:SetTextColor(GloryNowCrit4:GetTextColor());
					GloryNowCrit4:SetText("");	
					GloryNowCrit5:SetPoint("TOPLEFT", GloryNowBG1, "TOPLEFT", 380-(GloryNowCrit5:GetWidth()/2), -223);
				else
					local diff64 = GloryNowCrit4:GetStringWidth()-GloryNowCrit6:GetStringWidth();
					diff64 = math.floor(tonumber(diff64));
					if diff64 > 0 and math.fmod(tonumber(diff64), 2) > 0 then
						diff64 = diff64 + 1;
					end
					diff64 = diff64 / 2;
					GloryNowCrit5:ClearAllPoints();
					GloryNowCrit5:SetPoint("TOPLEFT", GloryNowBG1, "TOPLEFT", (380-(GloryNowCrit5:GetWidth()/2))+diff64, -223);
				end
			elseif ( critnum == 2 ) then
					local diff21 = GloryNowCrit1:GetStringWidth()-GloryNowCrit2:GetStringWidth();
					diff21 = math.floor(tonumber(diff21));
					if diff21 > 0 and math.fmod(tonumber(diff21), 2) > 0 then
						diff21 = diff21 + 1;
					end
					diff21 = diff21 / 2;
					GloryNowCrit2:ClearAllPoints();
					GloryNowCrit2:SetPoint("TOPLEFT", GloryNowBG1, "TOPLEFT", (386+diff21), -212);			
			else
				GloryNowCrit1:SetText("");
				GloryNowCrit2:SetText("");
				GloryNowCrit3:SetText("");	
				GloryNowCrit4:SetText("");
				GloryNowCrit5:SetText("");
				GloryNowCrit6:SetText("");					
			end
		else
			GloryNowCrit1:SetText("");
			GloryNowCrit2:SetText("");
			GloryNowCrit3:SetText("");
			GloryNowCrit4:SetText("");
			GloryNowCrit5:SetText("");
			GloryNowCrit6:SetText("");				
		end
	end
end


function GloryNow_MouseOverInstance(newindex)
	--hide achievement desc
	GloryNowNameAch:SetText("");
	GloryNowText:SetText("");
	GloryNowRecordTime1:SetText("");
	GloryNowRecordTime2:SetText("");
	GloryNowCrit1:SetText("");
	GloryNowCrit2:SetText("");
	GloryNowCrit3:SetText("");	
	GloryNowCrit4:SetText("");
	GloryNowCrit5:SetText("");
	GloryNowCrit6:SetText("");
	GloryNowTitle1:SetText("");
	GloryNowTitle2:SetText("");			
	glorynow_currentover = newindex;
	GloryNowIconBig:SetBackdrop({bgFile = glorynow_icons[newindex], 
                                            edgeFile = "", 
                                            tile = false, tileSize = 16, edgeSize = 8, 
                                            insets = { left = 0, right = 0, top = 0, bottom = 0 }});
      GloryNowName:SetText(glorynow_names[newindex]);
      --set the achievement icons
      GloryNow_SetAchIconsOver();
end

function GloryNow_MouseLeaveInstance()
	if glorynow_currentclicked then
		GloryNowIconBig:SetBackdrop({bgFile = glorynow_icons[glorynow_currentclicked], 
							edgeFile = "", 
							tile = false, tileSize = 16, edgeSize = 12, 
							insets = { left = 0, right = 0, top = 0, bottom = 0 }});
		GloryNowName:SetText(glorynow_names[glorynow_currentclicked]);
		
	else
		GloryNowIconBig:SetBackdrop({bgFile = "", 
							edgeFile = "", 
							tile = false, tileSize = 16, edgeSize = 12, 
							insets = { left = 0, right = 0, top = 0, bottom = 0 }});
		GloryNowName:SetText("");
		GloryNowTitle1:SetText("GloryNow");
		GloryNowTitle2:SetText("Heroic Dungeon Achievement Browser");	
						
	end
	GloryNow_SetAchIconsLeave();
	if ( glorynow_currentclickedach ) then
		GloryNow_MouseLeaveAch(glorynow_currentclickedach);
	end

end

function GloryNow_ClickInstance(newindex)
	glorynow_currentclicked = newindex;
	glorynow_currentclickedach = nil;
end


function GloryNow_MouseOverAch(index)
	local IDNumber, Title, Points, Completed, Month, Day, Year, Description, Flags, Image, RewardText = GetAchievementInfo(glorynow_ids[glorynow_currentclicked][index]);
	GloryNowNameAch:SetText(Title);
	GloryNowNameAch:ClearAllPoints();
	GloryNowNameAch:SetPoint("TOPLEFT", GloryNowBG1, "TOPLEFT", 375-(GloryNowNameAch:GetWidth()/2), -115);
	GloryNowText:SetText(Description);
	GloryNow_CheckForSpecialAchievement(IDNumber);

end

function GloryNow_MouseLeaveAch(index)
		if ( glorynow_ids[glorynow_currentclicked][index] ) then
			local IDNumber, Title, Points, Completed, Month, Day, Year, Description, Flags, Image, RewardText = GetAchievementInfo(glorynow_ids[glorynow_currentclicked][index]);
			GloryNowNameAch:SetText(Title);
			GloryNowNameAch:ClearAllPoints();
			GloryNowNameAch:SetPoint("TOPLEFT", GloryNowBG1, "TOPLEFT", 375-(GloryNowNameAch:GetWidth()/2), -115);
			GloryNowText:SetText(Description);
			GloryNow_CheckForSpecialAchievement(IDNumber);
		end
end

function GloryNow_ClickAch(index)
	glorynow_currentclickedach = index;
end

function GloryNow_ReportAch(index)
	local IDNumber = GetAchievementInfo(glorynow_ids[glorynow_currentclicked][index])
	SendChatMessage(GetAchievementLink(IDNumber),"PARTY");	
end

function GloryNow_SetAchIconsLeave()
	if ( glorynow_currentclicked ) then
		for i=1, 5, 1 do
			if ( glorynow_ids[glorynow_currentclicked][i] ) then
				local IDNumber, Title, Points, Completed, Month, Day, Year, Description, Flags, Image, RewardText = GetAchievementInfo(glorynow_ids[glorynow_currentclicked][i]);      	
				getglobal("GloryNowAch"..i):SetBackdrop({bgFile = Image, 
		                          edgeFile = "", tile = false, tileSize = 16, edgeSize = 8, 
		                          insets = { left = 0, right = 0, top = 0, bottom = 0 }});
		      	if ( Completed )then
	            		getglobal("GloryNowAch"..i):SetBackdropColor(1,1,1,1);
	           		else
	           		 	getglobal("GloryNowAch"..i):SetBackdropColor(0.5,0.5,0.5,0.8);
	           		end                    
		      else
				getglobal("GloryNowAch"..i):SetBackdrop({bgFile = "", 
		                          edgeFile = "", tile = false, tileSize = 16, edgeSize = 8, 
		                          insets = { left = 0, right = 0, top = 0, bottom = 0 }});	  
		      end
		end
	else
		for i=1, 5, 1 do
			getglobal("GloryNowAch"..i):SetBackdrop({bgFile = "", 
	                          edgeFile = "", tile = false, tileSize = 16, edgeSize = 8, 
	                          insets = { left = 0, right = 0, top = 0, bottom = 0 }});	  	
	      end	
	end
end	

function GloryNow_SetAchIconsOver()
      for i=1, 5, 1 do
      	if ( glorynow_ids[glorynow_currentover][i] ) then
			local IDNumber, Title, Points, Completed, Month, Day, Year, Description, Flags, Image, RewardText = GetAchievementInfo(glorynow_ids[glorynow_currentover][i]);      	
      		getglobal("GloryNowAch"..i):SetBackdrop({bgFile = Image, 
	                          edgeFile = "", tile = false, tileSize = 16, edgeSize = 8, 
	                          insets = { left = 0, right = 0, top = 0, bottom = 0 }});
	            if ( Completed )then
	            	getglobal("GloryNowAch"..i):SetBackdropColor(1,1,1,1);
	            else
	            	getglobal("GloryNowAch"..i):SetBackdropColor(0.5,0.5,0.5,0.8);
	            end
	            
	      else
      		getglobal("GloryNowAch"..i):SetBackdrop({bgFile = "", 
	                          edgeFile = "", tile = false, tileSize = 16, edgeSize = 8, 
	                          insets = { left = 0, right = 0, top = 0, bottom = 0 }});	  
	      end
	end
end	

function GloryNow_OnUpdate(arg1)
	if ( glorynow_currenttimer ) then
		glorynow_time = glorynow_time + arg1;
	end
end

function GloryNow_StartTimer(bossname)
	glorynow_time = 0;
	glorynow_currenttimer = bossname;
end

function GloryNow_StopTimer()
	local timeinseconds = math.ceil(glorynow_time);
	local bossdeath = glorynow_currenttimer;
	glorynow_currenttimer = false;
	if ( glorynow_bossids[bossdeath] ) then
		local achievementid = glorynow_bossids[bossdeath][1];
		if ( timeinseconds <= glorynow_bossids[bossdeath][2] ) then
			--eligible, set into minutes and seconds
			local minutes = math.floor(timeinseconds/60);
			local seconds = math.fmod(timeinseconds,60);
			--check for current record
			if ( glorynow_saved[achievementid][1] ) then
				--we have a time already, compare
				local oldm = glorynow_saved[achievementid][1];
				local olds = glorynow_saved[achievementid][2];
				if ( minutes <= oldm ) and ( seconds < olds ) then
					--new record
					--set into table
					glorynow_saved[achievementid][1] = minutes;
					glorynow_saved[achievementid][2] = seconds;
					local IDNumber, Title = GetAchievementInfo(achievementid);
					local stringseconds = seconds;
					if ( stringseconds < 10 ) then
						stringseconds = "0"..tostring(seconds);
					end						
					GL_MSG("New Best Time for '"..Title.."':  "..minutes..":"..stringseconds);
				else

				end
			else
				--no record yet: put in this one
				glorynow_saved[achievementid][1] = minutes;
				glorynow_saved[achievementid][2] = seconds;
				local IDNumber, Title = GetAchievementInfo(achievementid);
				local stringseconds = seconds;
				if ( stringseconds < 10 ) then
					stringseconds = "0"..tostring(seconds);
				end						
				GL_MSG("New Best Time for '"..Title.."':  "..minutes..":"..stringseconds);		
			end

		else
		end
	end
	
end

function GloryNow_NumberCompleted()
	local completed = 0;
	for k,v in pairs(glorynow_ids) do
		for o,p in pairs(v) do
			local IDNumber, Title, Points, comp = GetAchievementInfo(p);
			if ( comp ) then
				completed = completed + 1;
			end
		end
	end
	return completed;			
end

function GloryNow_OnLoad()	
	GloryNow:Show();
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CHAT_MSG_MONSTER_YELL");
	this:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	this:RegisterEvent("CHAT_MSG_SYSTEM");
	SlashCmdList["GLORYNOW"] = GloryNow_Slashhandler;
	SLASH_GLORYNOW1 = "/glory";
	SLASH_GLORYNOW2 = "/glorynow";	
end



function GloryNow_OnEvent(frame, event, arg1, arg2)
	if ( event == "HITHERE" ) then
	elseif ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( glorynow_bosses[arg2] ) then
			if ( arg1 == glorynow_bosses[arg2] ) then
				--check for heroic mode
				if ( GetCurrentDungeonDifficulty() == 2 ) then
					--we found a valid starter
					if ( arg2 == "Drakos the Interrogator" ) then
						GloryNow_StartTimer("Ley-Guardian Eregos");
					else
						GloryNow_StartTimer(arg2);
					end
				end
			end
		end

	elseif ( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		if ( glorynow_bosses[arg7] ) then
			if ( arg2 == "UNIT_DIED" ) then
				--check for heroic mode
				if ( GetCurrentDungeonDifficulty() == 2 ) then
					--we found valid stop event
					GloryNow_StopTimer();
				end
			end
		end
	elseif ( event == "CHAT_MSG_SYSTEM" ) then
		if ( arg1 == "You are now saved to this instance" ) then
			if ( GetRealZoneText() == "The Culling of Stratholme" ) then
				GloryNow_StartTimer("Infinite Corruptor");
			end
		end
	elseif ( event == "VARIABLES_LOADED" ) then
		GloryNow_Disable();
		GloryNowName:SetText("");
		GloryNowIconBig:SetBackdrop({bgFile = "", 
							edgeFile = "", 
							tile = false, tileSize = 16, edgeSize = 12, 
							insets = { left = 0, right = 0, top = 0, bottom = 0 }});	
		for i=1,5,1 do					
			getglobal("GloryNowAch"..i):SetBackdrop({bgFile = "", 
										edgeFile = "", tile = false, tileSize = 16, edgeSize = 8, 
										insets = { left = 0, right = 0, top = 0, bottom = 0 }});
		end					
		GloryNowText:SetWidth(300);
		GloryNowRecordTime1:SetWidth(300);
		GloryNowRecordTime2:SetWidth(300);	
		GloryNowRecordTime2:SetTextColor(0.2,1,0.2,1);	
		GloryProgress:SetMinMaxValues(0, 39);
		GloryProgress:SetStatusBarTexture("Interface\\AddOns\\GloryNow\\smooth.tga");
		GloryProgress:SetStatusBarColor(0.2, 0.2, 0.7, 1);	
		GloryNowTitle1:SetText("GloryNow");
		GloryNowTitle2:SetText("Heroic Dungeon Achievement Browser");
		

	end
end

function GloryNow_Slashhandler(msg)
	local i,j, cmd, param1 = string.find(msg, "^([^ ]+) ([^ ]+)");
	if ( param1 ) then
		param1 = string.upper(string.sub(param1, 1, 1))..string.lower(string.sub(param1, 2));
	end
	if (not cmd) then 
		cmd = msg;
	end
	if (not cmd) then 
		cmd = ""; 
	end
	if ( cmd == "on" or cmd == "show" ) then
		GloryNow_Enable();
	end
	if ( cmd == "off" or cmd == "hide" ) then
		GloryNow_Disable();

	end
	if ( cmd == "current" ) then
		GL_MSG(math.ceil(glorynow_time));
		GL_MSG("Minutes: "..math.floor(math.ceil(glorynow_time)/60));
		GL_MSG("Seconds: "..math.fmod(math.ceil(glorynow_time),60));
	end
	if ( cmd == "zone" ) then
		GL_MSG(GetRealZoneText());
	end
	if ( cmd == "" ) then
		if ( GloryNowBG:IsShown() ) then
			GloryNow_Disable();
		else
			GloryNow_Enable();
		end
	end
end

function GL_MSG(string)
	DEFAULT_CHAT_FRAME:AddMessage(string);
end

function GloryNow_Disable()
		GloryNowIconBig:SetBackdrop({bgFile = "", 
							edgeFile = "", 
							tile = false, tileSize = 16, edgeSize = 12, 
							insets = { left = 0, right = 0, top = 0, bottom = 0 }});
		GloryNowName:SetText("");
		GloryNowNameAch:SetText("");
		GloryNowText:SetText("");
		GloryNowRecordTime1:SetText("");
		GloryNowRecordTime2:SetText("");
		GloryNowCrit1:SetText("");
		GloryNowCrit2:SetText("");
		GloryNowCrit3:SetText("");	
		GloryNowCrit4:SetText("");
		GloryNowCrit5:SetText("");
		GloryNowCrit6:SetText("");			
		for i=1, 5, 1 do
			getglobal("GloryNowAch"..i):SetBackdrop({bgFile = "", 
	                          edgeFile = "", tile = false, tileSize = 16, edgeSize = 8, 
	                          insets = { left = 0, right = 0, top = 0, bottom = 0 }});	  	
	      end			
	      glorynow_currentclicked = nil;
	      glorynow_currentclickedach = nil;
		GloryNowTitle1:SetText("GloryNow");
		GloryNowTitle2:SetText("Heroic Dungeon Achievement Browser");
		GloryNowBG:Hide();
end

function GloryNow_Enable()
		local compl = GloryNow_NumberCompleted();
		if ( compl == 0 ) or ( compl == 39 ) then
			GloryProgressString:SetText("");
		else	
			GloryProgressString:SetText(compl.."/".."39");
		end
		GloryProgress:SetValue(compl);
		GloryNowBG:Show();
end